# 1 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/globals.c"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/globals.c"
# 9 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/globals.c"
# 1 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/aklabeth.h" 1
# 32 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/aklabeth.h"
# 1 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/struct.h" 1
# 9 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/struct.h"
typedef struct _Coord
{ unsigned int x,y; } COORD;



typedef struct _Rect
{
 int left,top,right,bottom;
} RECT;



typedef struct _WorldMap
{
 unsigned int MapSize;
 unsigned char Map[(21)]
       [(21)];
} WORLDMAP;



typedef struct _Monster
{
 COORD Loc;
 unsigned int Type;
 unsigned int Strength;
 int Alive;
} MONSTER;



typedef struct _DungeonMap
{
 unsigned int MapSize;
 unsigned char Map[(11)]
       [(11)];
 int MonstCount;
 MONSTER Monster[(10)];
} DUNGEONMAP;



typedef struct _Player
{
 char Name[(8)+1];
 COORD World;
 COORD Dungeon;
 COORD DungDir;
 char Class;
 int HPGain;
 unsigned int Level;
 int Skill;
 int Task;
 int TaskCompleted;
 unsigned int LuckyNumber;
 unsigned int Attributes;
 unsigned int Objects;
 unsigned long int Attr[(6)];
 unsigned long int Object[(6)];
} PLAYER;
# 33 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/aklabeth.h" 2
# 47 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/aklabeth.h"
void DRAWTile(unsigned char );
void _DRAWSetRect(RECT *, int, int, int, int);
void DRAWMonster(int,int,int,int);
void DRAWDungeon(const RECT *, const RECT *,int,int,int,int,int, int);
void DRAWText(char *,...);

void MONSTAttack(PLAYER *,DUNGEONMAP *);

int MAINSuper(void);
void MAINSetup(void);
void MAINStart(void);

void PLAYERInit(PLAYER *);
void PLAYERDebug(PLAYER *);
void PLAYERDemo(PLAYER *);
void PLAYERCharacter(PLAYER *);
void PLAYERInv(PLAYER *);

void DEADCode(PLAYER *);
int DEADGetYesNo(void);

char *GLOObjName(unsigned int);
char *GLOAttribName(unsigned int);
char *GLOClassName(char);
char *GLOMonsterName(unsigned int);
char *GLOMonsterNameAttribute(int);
unsigned int GLOMonsterLevel(unsigned int);
void GLOGetInfo(unsigned int n,unsigned int *,unsigned int *,char *);

void TOWNEnter(WORLDMAP *,PLAYER *);

void BRITISHEnter(WORLDMAP *,PLAYER *);

void WORLDCreate(PLAYER *,WORLDMAP *);
void WORLDDraw(PLAYER *,WORLDMAP *,int);
void WORLDDrawOnce(PLAYER *p,WORLDMAP *m,int ShowAsMap);
unsigned char WORLDRead(WORLDMAP *, int, int);

void DUNGEONCreate(PLAYER *,DUNGEONMAP *);

void DDRAWDraw(PLAYER *,DUNGEONMAP *);
int DDRAWFindMonster(DUNGEONMAP *,COORD *);

void ATTACKMonster(PLAYER *,DUNGEONMAP *);


void MOVEEnterExit(WORLDMAP *,PLAYER *,DUNGEONMAP *);
void MOVEMove(int,WORLDMAP *,PLAYER *,DUNGEONMAP *, int, int);
void MOVERotLeft(COORD *);
# 167 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/aklabeth.h"
extern unsigned int tenthFood;
void HWStatus();
# 177 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/aklabeth.h"
extern char statusString[];
# 10 "/Users/chrissalo/NetBeansProjects/Vide/projects/VecAkalabeth_II/source/globals.c" 2

struct _OInfStruct
  { char *Name; unsigned int Cost; unsigned int MaxDamage; char Key; };
struct _MInfStruct
  { char *Name; unsigned int Level; };

static struct _OInfStruct const _OInfo[] =
 {
  { "Food",1,0,'F' },
  { "Rapier",8,10,'R' },
  { "Axe",5,5,'A' },
  { "Shield",6,1,'S' },
  { "Bow+Arrow",3,4,'B' },
  { "Amulet",15,0,'M' }
 };

static struct _MInfStruct const _MInfo[] =
 {
  { "Skeleton",1 },
  { "Thief",2 },
  { "Giant Rat",3 },
  { "Orc",4 },
  { "Viper",5 },
  { "Carrion Crawler",6 },
  { "Gremlin",7 },
  { "Mimic",8 },
  { "Daemon",9 },
  { "Balrog",10 }
 };
static char * const _MInfoAttribute[] =
 {
   "a Skeleton" ,
   "a Thief" ,
   "a Giant Rat" ,
   "an Orc" ,
   "a Viper",
   "a Carrion Crawler",
   "a Gremlin",
   "a Mimic",
   "a Daemon",
   "a Balrog"
 };

static char * const _AName[] =
 { "HP", "Strength", "Dexterity", "Stamina",
  "Wisdom", "Gold" };







char *GLOObjName(unsigned int n)
{ return _OInfo[n].Name; }


void GLOGetInfo(unsigned int n,unsigned int *pDamage,unsigned int *pCost,char *pKey)
{
 if (pDamage != 0) *pDamage = _OInfo[n].MaxDamage;
 if (pCost != 0) *pCost = _OInfo[n].Cost;
 if (pKey != 0) *pKey = _OInfo[n].Key;
}







char *GLOAttribName(unsigned int n)
{
return _AName[n];
}







char *GLOClassName(char c)
{
 return (c == 'F') ? "Fighter":"Mage";
}

char *GLOMonsterName(unsigned int n)
{
 return _MInfo[n-1].Name;
}

char *GLOMonsterNameAttribute(int n)
{
 return _MInfoAttribute[n-1];
}

unsigned int GLOMonsterLevel(unsigned int n)
{
 return _MInfo[n-1].Level;
}
