 .module veccyasm.pre.s
 .area .text

SPRITE_SCALE        =        0x0d; 80 highest possible value
SHITREG_POKE_VALUE  =        0x01 


; PC not usable :-)

; cmpx #4
; pshs d,y,x,pc,u,cc;16
; puls d,y,x,pc,u,cc; 16
; pshs y,x,pc,u,d;15
; puls y,x,pc,u,d; 15
; pshs y,x,pc,u,cc;14
; puls y,x,pc,u,cc; 14
; pshs a,x,pc,u,cc;13
; puls a,x,pc,u,cc;13
; pshs x,pc,u,cc;12
; puls x,pc,u,cc;12
; pshs pc,u,d;11
; puls pc,u,d;11
; pshs pc,u,cc;10
; puls pc,u,cc;10
; pshs u,d;9
; puls u,d;9
; pshs u,cc;8
; puls u,cc;8
; pshs u;7
; puls u;7
; pshs cc;6
; puls cc;6
; tfr a,a; 6
; brn 0; 3
; NOP ; 2


 

;/* HIGHEST SCALE FOR SMARTLIST + CONTINUE is 16!

;***************************************************************************
; DEFINE SECTION
;***************************************************************************
Vec_Pattern         =      0xC829                        ;Dot pattern (bits) 
music1              =      0xFD0D 
VIA_port_b          =      0xD000                        ;VIA port B data I/O register 
VIA_port_a          =      0xD001                        ;VIA port A data I/O register (handshaking) 
VIA_t1_cnt_lo       =      0xD004                        ;VIA timer 1 count register lo (scale factor) 
VIA_t1_cnt_hi       =      0xD005                        ;VIA timer 1 count register hi 
VIA_shift_reg       =      0xD00A                        ;VIA shift register 
VIA_cntl            =      0xD00C                        ;VIA control register 
VIA_int_flags       =      0xD00D                        ;VIA interrupt flags register 
Intensity_5F        =      0xF2A5                        ; 
Wait_Recal          =      0xF192                        ; 
Moveto_d            =      0xF312                        ; 
Vec_Joy_1_X         =      0xC81B                        ;Joystick 1 left/right 
Joy_Digital         =      0xF1F8 
;***************************************************************************
; HEADER SECTION
;***************************************************************************
; The cartridge ROM starts at address 0
                    .area .text     

;***************************************************************************
; ROUTINE SECTION
;***************************************************************************
; Warning - direct line found!
;                    direct   0xd0 
;***************************************************************************


; for scale 7 
; we need WAIT6 after a poke to hi
; followd directly by a set_y_int
; todo 
; last draw could contain 0xF in A
; than load not needed - attention 
; when cycles are not done for load, than shift value might be needed 2 higher!
; also in X could be some sensible value in X for one of the other 
;SMVB_lastDraw_rts2                                ;#isfunction  
; list format
; y pos byte -> REG A
; VIA_B for x reg = 01 *256 + x pos byte -> REG X
; pointer to draw function -> PC
; 5 bytes per "position" (except continuous)
; reg A must be constantly == 0!
; opti finding
; a)  Findings T1 can be 2 cycles "off" -> smartlist max scale of "optimium" reduced from 9 to 7 scale :-(
; b ) y and z sampling need up to 4 cycles to bare fruit (poke b reg)
;     90% vectrex (guess) need 0 cycles
;     95% vectrex are content with 2 cycles (1 nop)
;     some few vectrex NEED 4 cycles!!! ARGH!
; c)  std to reg b of via (Y Reg) does not always / everywhere work
;
;
; delays needed for 5% of vectrex
; cost on a "full" screen
; about 2000 cycles
;VECTREX_SAVE_DELAY  =        1 
SHITREG_POKE_VALUE  =        0x01 




;

;
  
                    .setdp   0xd000,_DATA 



VB_SPRITE_SCALE     =        SPRITE_SCALE 
; NOPS add one less, since PULL X is one cycle more than pull a!
;***************************************************************************
 .globl _drawMountain
_drawMountain:
                                           ;#isfunction  
 pshs u
 ldu #_SMVB_MountainList

                    clra     
                    pulu     b,x,pc 
 .globl _drawTown
_drawTown:
                                           ;#isfunction  
 pshs u
 ldu #_SM_TownList

                    clra     
                    pulu     b,x,pc 

 .globl _drawTree
_drawTree:

 pshs u
 ldu #_SM_TreeList

                    clra     
                    pulu     b,x,pc 


 .globl _drawCastle
_drawCastle:

 pshs u
 ldu #SM_CastleList

                    clra     
                    pulu     b,x,pc 


 .globl _drawDungeon
_drawDungeon:

 pshs u
 ldu #_SM_DungeonList

                    clra     
                    pulu     b,x,pc 
 .globl _Draw_VLp_lessGap
_Draw_VLp_lessGap:
 pshs u
; macro call ->  Draw_VLp_lessGap
                    LDD      1,X                          ;Get next coordinate pair 
                    STA      *VIA_port_a                  ;Send Y to A/D 
                    CLR      *VIA_port_b                  ;Enable mux 
                    LDA      ,X                           ;Get pattern byte 
                    INC      *VIA_port_b                  ;Disable mux 
                    STB      *VIA_port_a                  ;Send X to A/D 
                    ldb      #0 
                    STA      *VIA_shift_reg               ;Store pattern in shift register 
                    STB      *VIA_t1_cnt_hi               ;Clear T1H 
                    LDA      #0x40                         ;B-reg = T1 interrupt bit 
; 0 is ok
;
                    LEAX     3,X                          ;Advance to next point in list 
 .globl LF425_lg_11
LF425_lg_11: 
                    BITA     VIA_int_flags               ;Wait for T1 to time out 
                    BEQ      LF425_lg_11 
                    LDA      ,X                           ;Get next pattern byte 
                    bgt      macroEnd1 
 .globl Draw_VLp_lessGap_11
Draw_VLp_lessGap_11: 
                    STB      *VIA_shift_reg               ;Clear shift register (blank output) 
                    LDD      1,X                          ;Get next coordinate pair 
                    STA      *VIA_port_a                  ;Send Y to A/D 
                    CLR      *VIA_port_b                  ;Enable mux 
                    LDA      ,X                           ;Get pattern byte 
                    INC      *VIA_port_b                  ;Disable mux 
                    STB      *VIA_port_a                  ;Send X to A/D 
                    ldb      #0 
                    STA      *VIA_shift_reg               ;Store pattern in shift register 
                    STB      *VIA_t1_cnt_hi               ;Clear T1H 
                    LDA      #0x40                         ;B-reg = T1 interrupt bit 
; 0 is ok
;
                    LEAX     3,X                          ;Advance to next point in list 
 .globl LF425_lg1
LF425_lg1: 
                    BITA     VIA_int_flags               ;Wait for T1 to time out 
                    BEQ      LF425_lg1 
                    LDA      ,X                           ;Get next pattern byte 
                    BLE      Draw_VLp_lessGap_11         ;Go back if high bit of pattern is set 
 .globl macroEnd1
macroEnd1: 
                    STB      *VIA_shift_reg               ;Clear shift register (blank output) 
                    puls     u,pc 

ZERO_DELAY          =      1                            ; delay 7 counter is exactly 111 cycles delay between zero SETTING and zero unsetting (in moveto_d) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;U = address of vectorlist
;X = (y,x) position of vectorlist (this will be point 0,0), positioning on screen
;A = scalefactor "Move" (after sync)
;B = scalefactor "Vector" (vectors in vectorlist)
;
;     mode, rel y, rel x,                                             
;     mode, rel y, rel x,                                             
;     .      .      .                                                
;     .      .      .                                                
;     mode, rel y, rel x,                                             
;     0x02
; where mode has the following meaning:         
; negative draw line                    
; 0 move to specified endpoint                              
; 1 sync (and move to list start and than to place in vectorlist)      
; 2 end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 .globl _draw_synced_list
_draw_synced_list: 





draw_synced_list2: 
                    pshs     u 
                    lda      2+2,s                        ; calling from C 
                    ldu      3+2,s                        ; than parameters are on stack 
                    sta      *VIA_t1_cnt_lo               ; to timer t1 (lo= 
                                                          ; first list entry (first will be a sync + moveto_d, so we just stay here!) 
                    lda      ,u+                          ; this will be a "1" 
                    bra      sync 

 .globl nextIsSyncTo
nextIsSyncTo: 
; macro call ->                     MY_MOVE_TO_B_END  
                    LDb      #0x40                         ; 
 .globl LF33D11
LF33D11:            BITb     *VIA_int_flags               ; 
                    BEQ      LF33D11                      ; 
 .globl sync
sync: 
; zero integrators
                    ldb      #0xCC                         ; zero the integrators 
                    stb      *VIA_cntl                    ; store zeroing values to cntl 
                    clr      *VIA_port_a                  ; reset integrator offset 
                    ldb      #0b10000010 
                    stb      *VIA_port_b                  ; while waiting, zero offsets 
                    deca                                  ; test if real sync - or end of list (2) 
                    bne      drawdone                     ; if end of list -> jump 
                    inc      *VIA_port_b 
                    tfr      x,d                          ; load our coordinates of "entry" of vectorlist 
;                    MY_MOVE_TO_D_START  
; we know B = 0
                    STA      *VIA_port_a                  ;Store Y in D/A register 
                    LDA      #0xCE                         ;Blank low, zero high? 
                    STA      *VIA_cntl                    ; 
;                    CLRA     
                    STB      *VIA_port_b                  ;Enable mux ; hey dis si "break integratorzero 440" 
 nop ; y must be set more than xx cycles on some vectrex 
                    INC      *VIA_port_b                  ;Disable mux 
                    STB      *VIA_port_a                  ;Store X in D/A register 
                    STB      *VIA_t1_cnt_hi               ;enable timer 


 .globl nextIsMoveTo
nextIsMoveTo: 
; macro call ->                     MY_MOVE_TO_B_END  
                    LDb      #0x40                         ; 
 .globl LF33D22
LF33D22:            BITb     *VIA_int_flags               ; 
                    BEQ      LF33D22                      ; 
 .globl moveTo
moveTo: 
                    ldd      ,u                           ; do our "internal" moveto d 
; macro call ->                     MY_MOVE_TO_D_START  
                    STA      *VIA_port_a                  ;Store Y in D/A register 
                    LDA      #0xCE                         ;Blank low, zero high? 
                    STA      *VIA_cntl                    ; 
                    CLRA     
                    STA      *VIA_port_b                  ;Enable mux ; hey dis si "break integratorzero 440" 
 nop ; y must be set more than xx cycles on some vectrex 
                    INC      *VIA_port_b                  ;Disable mux 
                    STB      *VIA_port_a                  ;Store X in D/A register 
                    STA      *VIA_t1_cnt_hi               ;enable timer 
                    leau     2,u 
                    lda      ,u+                          ; load next "mode" byte 
                    beq      nextIsMoveTo                 ; if 0, than we should move somewhere 
                    bpl      nextIsSyncTo                 ; if still positive it is a 1 pr 2 _> goto sync 

                    lda      ,u+                           ;Get next coordinate pair 
; macro call ->                     MY_MOVE_TO_B_END  
                    LDb      #0x40                         ; 
 .globl LF33D44
LF33D44:            BITb     *VIA_int_flags               ; 
                    BEQ      LF33D44                      ; 
 .globl nextListEntry
nextListEntry: 
; now we should draw a vector 
                    STA      *VIA_port_a                  ;Send Y to A/D 
                    LDD      #0x0001                           ;Get pattern byte 
                    STA      *VIA_port_b                  ;Enable mux 
 nop 
                    STB      *VIA_port_b                  ;Disable mux 
                    ldb      ,u                           ;Get next coordinate pair 
                    STB      *VIA_port_a                  ;Send X to A/D 
                    DEC      *VIA_shift_reg               ;Store pattern in shift register 
                    STA      *VIA_t1_cnt_hi               ;Clear T1H 
                    LDB      #0x40                         ;B-reg = T1 interrupt bit 
                    leau     1,u 
                    lda      ,u+                          ; load next "mode" byte 
                    beq      nextIsMove 
                    bpl      nextIsSync 
                    lda      ,u+                           ;Get next coordinate pair 
 .globl setPatternLoop
setPatternLoop: 
                    BITB     *VIA_int_flags               ;Wait for T1 to time out 
                    beq      setPatternLoop               ; wait till line is finished 
                    INC      *VIA_shift_reg               ; switch the light off (for sure) 
                    bra      nextListEntry 

 .globl nextIsMove
nextIsMove: 
 .globl setPatternLoop2
setPatternLoop2: 
                    BITB     *VIA_int_flags               ;Wait for T1 to time out 
                    beq      setPatternLoop2              ; wait till line is finished 
                    INC      *VIA_shift_reg               ; switch the light off (for sure) 
                    bra      moveTo 

 .globl nextIsSync
nextIsSync: 
 .globl setPatternLoop3
setPatternLoop3: 
                    BITB     *VIA_int_flags               ;Wait for T1 to time out 
                    beq      setPatternLoop3              ; wait till line is finished 
                    INC      *VIA_shift_reg               ; switch the light off (for sure) 
                    bra      sync 

 .globl drawdone
drawdone: 
                    puls     u                            ; correct stack and go back 
                    rts      





;***************************************************************************
;/* HIGHEST SCALE FOR SMARTLIST + CONTINUE is 16!
 .globl SMVB_setScale
SMVB_setScale:                                            ;#isfunction  
                    stb      *VIA_t1_cnt_lo 
                    pulu     b,x,pc 

 .globl SMVB_setIntensity
SMVB_setIntensity:                                          ;#isfunction  
; macro call ->                     WAIT10   
; macro call ->                     WAIT6    
                    tfr      a,a                          ; wait 6 cycles 
; macro call ->                     WAIT4    
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    sta      *VIA_port_a 
                    ldd      #0x0401 
                    sta      *VIA_port_b 
                    stb      *VIA_port_b 
                    pulu     b,x,pc 

 .globl SMVB_LightOff_Intensity
SMVB_LightOff_Intensity:                                      ;#isfunction  
; macro call ->                     WAIT10   
; macro call ->                     WAIT6    
                    tfr      a,a                          ; wait 6 cycles 
; macro call ->                     WAIT4    
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
 lda #0xce
                    STa      VIA_cntl                     ;/BLANK low and /ZERO low 
                    stb      *VIA_port_a 
                    ldd      #0x0401
                    sta      *VIA_port_b 
                    stb      *VIA_port_b 
 clra
                    pulu     b,x,pc 


 .globl SMVB_continue_yd4_yStays_single
SMVB_continue_yd4_yStays_single: ;#isfunction  
 .globl SMVB_continue_yStays_single
SMVB_continue_yStays_single:                               ;#isfunction  
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 


 .globl SMVB_continue7_single
SMVB_continue7_single:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS                              ; 21 
 nop 
; this is one pulu cycle more!
; thus ADD_NOPS can be one cycle less!
; minus 6!
                    pulu     b,x                          ; 5+3 
 .globl SMVB_continue6_single
SMVB_continue6_single:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS                              ; 21 
 nop 
                    pulu     b,x                          ; 5+3 
 .globl SMVB_continue5_single
SMVB_continue5_single:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS                              ; 21 
 nop 
                    pulu     b,x                          ; 5+3 
 .globl SMVB_continue4_single
SMVB_continue4_single:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS                              ; 21 
 nop 
                    pulu     b,x                          ; 5+3 
 .globl SMVB_continue3_single
SMVB_continue3_single:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS                              ; 21 
 nop 
                    pulu     b,x                          ; 5+3 
 .globl SMVB_continue2_single
SMVB_continue2_single:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS                              ; 21 
 nop 
                    pulu     b,x                          ; 5+3 
; continue uses same shift  
 .globl SMVB_continue_single
SMVB_continue_single:                                   ;#isfunction  
                    stb      *VIA_port_a                  ; 4 shift not changed, move might also be a draw 
; y is inherently known to be == old_x, y was = to 0 by generator
 .globl SMVB_continue_newY_eq_oldX_single
SMVB_continue_newY_eq_oldX_single:                       ;#isfunction  
                    sta      *VIA_port_b                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 


 .globl SMVB_continue_yd4_single
SMVB_continue_yd4_single:                                   ;#isfunction  
                    stb      *VIA_port_a                  ; 4 shift not changed, move might also be a draw 
; y is inherently known to be == old_x, y was = to 0 by generator
 .globl SMVB_continue_yd4_newY_eq_oldX_single
SMVB_continue_yd4_newY_eq_oldX_single:                       ;#isfunction  
                    sta      *VIA_port_b                  ; 4 
; macro call ->                     Y_DELAY_4                             ; 4 
 nop 
 nop 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc


 .globl SMVB_continue_single_sj
SMVB_continue_single_sj:                                   ;#isfunction  
                    stb      *VIA_port_a                  ; 4 shift not changed, move might also be a draw 
; y is inherently known to be == old_x, y was = to 0 by generator
 .globl SMVB_continue_newY_eq_oldX_single_sj
SMVB_continue_newY_eq_oldX_single_sj:                     ;#isfunction  
                    sta      *VIA_port_b                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 
; continue uses same shift
; y is inherently known to be == x, 
 .globl SMVB_continue_yd4_yEqx_single
SMVB_continue_yd4_yEqx_single: ;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY_HALF_4                          ; 4 
 nop 
; macro call ->  ADD_BURST
 

                    inc      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 

 .globl SMVB_continue_yEqx_single
SMVB_continue_yEqx_single:                                 ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY_HALF                          ; 4 
; macro call ->  Y_DELAY_HALF_4
 nop 
; macro call ->  ADD_BURST
 

 

                    inc      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_continue_tripple
SMVB_continue_tripple:                                     ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      cont2 

 .globl SMVB_continue_quadro
SMVB_continue_quadro:                                      ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      cont3 
 .globl SMVB_continue_hex
SMVB_continue_hex: ;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      cont5 
 .globl SMVB_continue_octo
SMVB_continue_octo:                                        ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next95                            ; wait 3 cycles 
 .globl next95
next95:
 .globl cont7
cont7: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next99                            ; wait 3 cycles 
 .globl next99
next99:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next104                            ; wait 3 cycles 
 .globl next104
next104:
 .globl cont6
cont6: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next108                            ; wait 3 cycles 
 .globl next108
next108:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next113                            ; wait 3 cycles 
 .globl next113
next113:
 .globl cont5
cont5: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next117                            ; wait 3 cycles 
 .globl next117
next117:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next122                            ; wait 3 cycles 
 .globl next122
next122:
 .globl cont4
cont4: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next126                            ; wait 3 cycles 
 .globl next126
next126:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next131                            ; wait 3 cycles 
 .globl next131
next131:
 .globl cont3
cont3: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next135                            ; wait 3 cycles 
 .globl next135
next135:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next140                            ; wait 3 cycles 
 .globl next140
next140:
 .globl cont2
cont2: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next144                            ; wait 3 cycles 
 .globl next144
next144:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      SMVB_repeat_same 

 .globl SMVB_repeat_same
SMVB_repeat_same:                                          ;#isfunction  
                    pulu     b,x 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     pc 
 .globl SMVB_continue_double
SMVB_continue_double:                                      ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY                               ; 4 
; macro call ->  Y_DELAY_4
 nop 
 nop 
; macro call ->  ADD_BURST
 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      SMVB_repeat_same 
 .globl SMVB_continue_yd4_double
SMVB_continue_yd4_double:;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     Y_DELAY_4                               ; 4 
 nop 
 nop 
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      SMVB_repeat_same 

 .globl SMVB_startMove_yd4_single
SMVB_startMove_yd4_single: ;#isfunction 
 .globl SMVB_startMove_single
SMVB_startMove_single:                                    ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     INIT_MOVE  
                    ldb      #0b11100000 
                    stb      *VIA_shift_reg               ; 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startMove_single_sj
SMVB_startMove_single_sj:                                 ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldu      ,u 
 
; macro call ->                     INIT_MOVE_SJ  
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    pulu     b,x,pc 

 .globl SMVB_startMove_yd4_single_sj
SMVB_startMove_yd4_single_sj:                                 ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldu      ,u 
; macro call ->                     INIT_MOVE_SJ  
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    pulu     b,x,pc 


 .globl SMVB_startMove_yd4_double
SMVB_startMove_yd4_double:                                    ;#isfunction  
 .globl SMVB_startMove_double
SMVB_startMove_double:                                    ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     INIT_MOVE  
                    ldb      #0b11100000 
                    stb      *VIA_shift_reg               ; 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      SMVB_repeat_same2 

 .globl SMVB_startDraw_tripple
SMVB_startDraw_tripple: ;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldb      #SHITREG_POKE_VALUE          ; 2 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      cont2 

 .globl SMVB_startDraw_double
SMVB_startDraw_double: ;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldb      #SHITREG_POKE_VALUE          ; 2 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      SMVB_repeat_same2 

 .globl SMVB_startMove_tripple
SMVB_startMove_tripple: ;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     INIT_MOVE  
                    ldb      #0b11100000 
                    stb      *VIA_shift_reg               ; 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    bra      move2 

 .globl SMVB_startMove_quadro
SMVB_startMove_quadro: ;#isfunction 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     INIT_MOVE  
                    ldb      #0b11100000 
                    stb      *VIA_shift_reg               ; 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    bra      move3 

 .globl move3
move3: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next200                            ; wait 3 cycles 
 .globl next200
next200:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
; macro call ->                     WAIT_BEFORE  
; macro call ->                     WAIT3    
                    brn      next205                            ; wait 3 cycles 
 .globl next205
next205:
 .globl move2
move2: 
; macro call ->                     WAIT_AFTER  
; macro call ->                     WAIT7    
; macro call ->                     WAIT5    
; macro call ->                     WAIT3    
                    brn      next209                            ; wait 3 cycles 
 .globl next209
next209:
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    jmp      SMVB_repeat_same2 

 .globl SMVB_repeat_same2
SMVB_repeat_same2:                                           ;#isfunction  
                    pulu     b,x 
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     pc 
 .globl SMVB_startMove_double_sj
SMVB_startMove_double_sj:                                  ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldu      ,u 
; macro call ->                     INIT_MOVE_SJ  
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 
; macro call ->                     ADD_NOPS  
 nop 
                    brn      nextA                            ; wait 3 cycles 
 .globl nextA
nextA:
                    brn      nextB                            ; wait 3 cycles 
 .globl nextB
nextB:
                    clr      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS                              ; reduced by ldu ,u - 5 cycles 
 nop 
                    pulu     b,x, pc 
 .globl SMVB_startMove_yStays_single
SMVB_startMove_yStays_single:                              ;#isfunction  
; macro call ->                     INIT_MOVE  
                    ldb      #0b11100000 
                    stb      *VIA_shift_reg               ; 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startMove_yStays_single_sj
SMVB_startMove_yStays_single_sj: 
                    ldu      ,u 
; macro call ->                     INIT_MOVE_SJ  
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    pulu     b,x,pc 
; assuming b = 1
 .globl SMVB_startDraw_yStays_single
SMVB_startDraw_yStays_single:                              ;#isfunction  
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
; assume b contains SHIFT

 .globl SMVB_startDraw_xyStays_single
SMVB_startDraw_xyStays_single:                             ;#isfunction  
                    stb      *VIA_shift_reg 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_yStays_single_sj
SMVB_startDraw_yStays_single_sj:                           ;#isfunction  
;                    ldb      #SHITREG_POKE_VALUE          ; 2 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_yd4_single
SMVB_startDraw_yd4_single:;#isfunction 
 .globl SMVB_startDraw_single
SMVB_startDraw_single:                                    ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldb      #SHITREG_POKE_VALUE          ; 2 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_single_sj
SMVB_startDraw_single_sj: 
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldb      #SHITREG_POKE_VALUE          ; 2 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi               ; 4 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_yEqx_single_sj
SMVB_startDraw_yEqx_single_sj:                             ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldb      #0x01 
                    stb      *VIA_shift_reg               ; 4 - ASSUMING SHITREG_POKE_VALUE = 1 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stb      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_yEqx_single
SMVB_startDraw_yEqx_single:                                ;#isfunction  
 .globl SMVB_startDraw_yd4_yEqx_single
SMVB_startDraw_yd4_yEqx_single:                                ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
                    ldb      #0x01 
                    stb      *VIA_shift_reg               ; 4 - ASSUMING SHITREG_POKE_VALUE = 1 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stb      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startMove_yEqx_single
SMVB_startMove_yEqx_single:                                ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->  Y_DELAY_HALF
; macro call ->  Y_DELAY_HALF_4
 nop 
; macro call ->  ADD_BURST
 

                    inc      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startMove_yd4_yEqx_single
SMVB_startMove_yd4_yEqx_single:                                ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->  Y_DELAY_HALF_4
 nop 
; macro call ->  ADD_BURST
 

                    inc      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 4 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startMove_xyStays_single
SMVB_startMove_xyStays_single: ;#isfunction 
                    sta      *VIA_t1_cnt_hi 
                    stb      *VIA_shift_reg 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 

 .globl SMVB_startMove_yEqx_single_sj
SMVB_startMove_yEqx_single_sj:                             ;#isfunction  
; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    inc      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 4 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 
 .globl SMVB_startMove_yd4_yEqx_single_sj
SMVB_startMove_yd4_yEqx_single_sj:                             ;#isfunction  

; macro call ->                     SET_Y_INT  
                    sta      *VIA_port_b                  ; 4 
                    stb      *VIA_port_a                  ; 4 
; macro call ->                     WAIT2    
 nop ;     wait 2 cycles 
; macro call ->  Y_DELAY_HALF_4
 nop 
; macro call ->  ADD_BURST
 

                    inc      *VIA_port_b 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 4 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 
 .globl SMVB_startMove_newY_eq_oldX_single
SMVB_startMove_newY_eq_oldX_single:;#isfunction  
                    sta      *VIA_port_b                  ; 4 
; macro call ->                     INIT_MOVE  
                    ldb      #0b11100000 
                    stb      *VIA_shift_reg               ; 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startMove_newY_eq_oldX_single_sj
SMVB_startMove_newY_eq_oldX_single_sj: ;#isfunction  
                    sta      *VIA_port_b                  ; 4 
                    ldu      ,u 
; macro call ->                     INIT_MOVE_SJ  
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
                    sta      *VIA_shift_reg               ; 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_newY_eq_oldX_single
SMVB_startDraw_newY_eq_oldX_single:                       ;#isfunction  
                    sta      *VIA_port_b                  ; 4 
                    ldb      #SHITREG_POKE_VALUE 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS  
 nop 
                    pulu     b,x,pc 
 .globl SMVB_startDraw_newY_eq_oldX_single_sj
SMVB_startDraw_newY_eq_oldX_single_sj:                    ;#isfunction  
                    sta      *VIA_port_b                  ; 4 
                    ldb      #SHITREG_POKE_VALUE 
                    stb      *VIA_shift_reg               ; 4 
; macro call ->  DELAY_NONE
; macro call ->  ADD_BURST
 
                    stx      *VIA_port_b                  ; 5 
                    sta      *VIA_t1_cnt_hi 
; macro call ->                     ADD_NOPS_NOU                          ; reduced by ldu ,u - 5 cycles 
 nop 
                    ldu      ,u 
                    pulu     b,x,pc 


 .globl SMVB_lastDraw_rts
SMVB_lastDraw_rts:                                         ;#isfunction  
 .globl SMVB_FlagWait
SMVB_FlagWait: 
                    bitb     *VIA_int_flags 
                    beq      SMVB_FlagWait 
                    sta      *VIA_shift_reg 
 .globl SMVB_rts
SMVB_rts:                                                 ;#isfunction  
 nop 
 nop 
;                    ldb      gameScale 
                    LDA      #0xCC 
                    STA      VIA_cntl                     ;/BLANK low and /ZERO low 
 nop 
 nop 
;                    stB      VIA_t1_cnt_lo 
; and ensures integrators are clean (good positioning!)
;                    ldd      #0 
                    stx      *VIA_port_b 
 puls u,pc
                    rts      

;// TODO CHECK WITH SHIELD + CO
 .globl SMVB_lastDraw_rts_stay
SMVB_lastDraw_rts_stay:                                    ;#isfunction  
;                    SET_Y_INT  
;                    Y_DELAY_HALF                          ; 4 
;                    ldd      #0x40E0 
;                    stx      <VIA_port_b                  ; 5 
;                    clr      <VIA_t1_cnt_hi 
;                    ADD_NOPS  
 .globl SMVB_FlagWait3
SMVB_FlagWait3:                                           ;#isfunction  
                    bitb     *VIA_int_flags 
                    beq      SMVB_FlagWait3 
                    sta      *VIA_shift_reg 
 nop 
 nop 
                    rts      

 .globl SMVB_lastMove_rts_stay
SMVB_lastMove_rts_stay:                                    ;#isfunction  
                    lda      #0x40 
 .globl SMVB_FlagWait3_2
SMVB_FlagWait3_2: 
                    bita     *VIA_int_flags 
                    beq      SMVB_FlagWait3_2 
                    rts      

; todo 
; last draw could contain 0xF in A
; than load not needed - attention 
; when cycles are not done for load, than shift value might be needed 2 higher!
; also in X could be some sensible value in X for one of the other 
 .globl SMVB_lastDraw_rts2
SMVB_lastDraw_rts2:                                        ;#isfunction  
;                    ldb      #0xf0 
 nop 
                    stb      *VIA_shift_reg 
 nop 
 nop 
 nop 
 nop 
;                    lda      gameScale 
;                    sta      <VIA_t1_cnt_lo 
; extended on purpose to gain one cycle of time
; to reset to 
; a) swithc light off before zeroing
; b) zero
 .globl SMVB_rts2
SMVB_rts2:                                                ;#isfunction  
                    ldb      #0xcc 
                    STb      VIA_cntl                    ;/BLANK low and /ZERO low 
                    stx      VIA_port_b 
; nop 10
                    puls     d,pc                         ; (D = y,x, pc = next object) 

; assumes b = 0
 .globl SMVB_Shift0_Intensity
SMVB_Shift0_Intensity:                                      ;#isfunction  
; macro call ->                     WAIT14   
                    pshs     u                            ; wait 14 cycles 
                    puls     u 
                    stb      *VIA_shift_reg 
                    sta      *VIA_port_a 
                    ldd      #0x0401 
                    sta      *VIA_port_b 
                    stb      *VIA_port_b 
                    pulu     b,x,pc 


 .globl _SMVB_MountainList
_SMVB_MountainList:
	.byte  0x67, 0x01,  0x3E
 .word SMVB_continue_single
	.byte -0x29, 0x01,  0x00
 .word SMVB_startDraw_single
	.byte  0x00, 0x01,  0x29 ; y was  0x00, now 0
 .word SMVB_startMove_newY_eq_oldX_single
	.byte  SHITREG_POKE_VALUE, 0x01, -0x53; y was  0x00, now SHIFT Poke
 .word SMVB_startDraw_yStays_single
	.byte -0x52, 0x01,  0x00
 .word SMVB_continue_single
	.byte  0x00, 0x01, -0x28 ; y was  0x00, now 0
 .word SMVB_startMove_newY_eq_oldX_single
	.byte  SHITREG_POKE_VALUE, 0x01,  0x52; y was  0x00, now SHIFT Poke
 .word SMVB_startDraw_yStays_single
	.byte -0x53, 0x01,  0x00
 .word SMVB_continue_single
	.byte  0x29, 0x01,  0x00 
 .word SMVB_startMove_single
	.byte SHITREG_POKE_VALUE, 0x01,  0x29; y was  0x00, now SHIFT
 .word SMVB_startDraw_newY_eq_oldX_single
	.byte -0x14, 0x01, -0x52
 .word SMVB_startMove_double
	.byte  0x29, 0x01,  0x00
 .word SMVB_startDraw_single
	.byte  0x00, 0x01, -0x29 ; y was  0x00, now 0
 .word SMVB_startMove_newY_eq_oldX_single
	.byte  SHITREG_POKE_VALUE, 0x01,  0x29; y was  0x00, now SHIFT Poke
 .word SMVB_startDraw_yStays_single
	.byte  0x2A, 0x01,  0x2A
 .word SMVB_continue4_single
	.byte  0x28, 0x01,  0x00
	.byte  0x00, 0x01, -0x2A
	.byte  0x53, 0x01,  0x00
	.byte -0x29, 0x01,  0x00
 .word SMVB_startMove_single
	.byte SHITREG_POKE_VALUE, 0x01, -0x29 ; y was  0x00, now SHIFT
 .word SMVB_startDraw_newY_eq_oldX_single
	.byte  0x40, 0x00,  0x00
 .word SMVB_lastDraw_rts

 .globl _SM_TownList
_SM_TownList:
	.byte -0x29, 0x01, -0x29; y is -0x29
 .word SMVB_continue_yEqx_single
	.byte  0x52, 0x01,  0x00
 .word SMVB_startDraw_single
	.byte  0x00, 0x01, -0x3E
 .word SMVB_continue7_single
	.byte  0x3E, 0x01,  0x00
	.byte  0x00, 0x01,  0x3E
	.byte -0x3E, 0x01,  0x00
	.byte  0x00, 0x01,  0x52
	.byte  0x3E, 0x01,  0x00
	.byte  0x00, 0x01,  0x3E
	.byte -0x3E, 0x01,  0x00
 .word SMVB_continue7_single
	.byte  0x00, 0x01, -0x3E
	.byte -0x52, 0x01,  0x00
	.byte  0x00, 0x01,  0x3E
	.byte -0x3E, 0x01,  0x00
	.byte  0x00, 0x01, -0x3E
	.byte  0x3E, 0x01,  0x00
	.byte  0x00, 0x01, -0x52
 .word SMVB_continue5_single

	.byte -0x3E, 0x01,  0x00
	.byte  0x00, 0x01, -0x3E
	.byte  0x3E, 0x01,  0x00
	.byte  0x00, 0x01,  0x3E
	.byte  0x40, 0x00,  0x00
 .word SMVB_lastDraw_rts

 .globl _SM_TreeList
_SM_TreeList:
	.byte -0x53, 0x01, -0x53; y is -0x53
 .word SMVB_continue_yEqx_single
	.byte  0x53, 0x01,  0x00
 .word SMVB_startDraw_double
	.byte  0x00, 0x01,  0x53
 .word SMVB_continue_double
	.byte -0x53, 0x01,  0x00
 .word SMVB_continue_double
	.byte  0x00, 0x01, -0x53
 .word SMVB_continue_double
	.byte  0x40, 0x00,  0x00
 .word SMVB_lastDraw_rts

 .globl SM_CastleList
SM_CastleList:

	.byte -0x4F, 0x01, -0x4F; y is -0x4F
 .word SMVB_continue_yEqx_single
	.byte  0x00, 0x01,  0x4F
 .word SMVB_startDraw_double
	.byte  0x4F, 0x01,  0x00
 .word SMVB_continue_double
	.byte  0x00, 0x01, -0x4F
 .word SMVB_continue_double
	.byte -0x4F, 0x01,  0x00
 .word SMVB_continue_double
	.byte  0x20, 0x01,  0x20; y is  0x20
 .word SMVB_startMove_yEqx_single
	.byte  0x00, 0x01,  0x5E
 .word SMVB_startDraw_single
	.byte  0x00, 0x01,  0x00; y was  0x5E, now 0
 .word SMVB_startMove_newY_eq_oldX_single
	.byte SHITREG_POKE_VALUE, 0x01, -0x5E ; y was  0x00, now SHIFT
 .word SMVB_startDraw_newY_eq_oldX_single
	.byte -0x5E, 0x01,  0x00
 .word SMVB_continue4_single
	.byte  0x5E, 0x01,  0x5E
	.byte -0x5E, 0x01,  0x00
	.byte  0x5E, 0x01, -0x5E
	.byte  0x40, 0x00,  0x00
 .word SMVB_lastDraw_rts
 .globl _SM_DungeonList
_SM_DungeonList:
	.byte -0x29, 0x01,  0x29
 .word SMVB_continue_single
	.byte  0x52, 0x01, -0x52
 .word SMVB_startDraw_single
	.byte  0x00, 0x01,  0x52
 .word SMVB_startMove_single
	.byte -0x52, 0x01, -0x52; y is -0x52
 .word SMVB_startDraw_yEqx_single
	.byte  0x40, 0x00,  0x00
 .word SMVB_lastDraw_rts
