/************************************************************************/
/************************************************************************/
/*																		*/
/*				Global Constants : Lists of things, etc.				*/
/*																		*/
/************************************************************************/
/************************************************************************/

#include "aklabeth.h"

struct _OInfStruct
		{ char *Name; unsigned int Cost; unsigned int MaxDamage; char Key; };
struct _MInfStruct
		{ char *Name; unsigned int Level; };

static struct _OInfStruct const _OInfo[] =
	{
		{ "Food",1,0,'F' },
		{ "Rapier",8,10,'R' },
		{ "Axe",5,5,'A' },
		{ "Shield",6,1,'S' },
		{ "Bow+Arrow",3,4,'B' },
		{ "Amulet",15,0,'M' }
	};

static struct _MInfStruct const _MInfo[] =
	{
		{ "Skeleton",1 },
		{ "Thief",2 },
		{ "Giant Rat",3 },
		{ "Orc",4 },
		{ "Viper",5 },
		{ "Carrion Crawler",6 },
		{ "Gremlin",7 },
		{ "Mimic",8 },
		{ "Daemon",9 },
		{ "Balrog",10 }
	};
static char * const  _MInfoAttribute[] =
	{
		 "a Skeleton" ,
		 "a Thief" ,
		 "a Giant Rat" ,
		 "an Orc" ,
		 "a Viper",
		 "a Carrion Crawler",
		 "a Gremlin",
		 "a Mimic",
		 "a Daemon",
		 "a Balrog" 
	};

static char * const _AName[] =
	{ 	"HP",		"Strength",	"Dexterity",	"Stamina",
		"Wisdom",	"Gold"  };

/************************************************************************/
/*																		*/
/*						Return name of object							*/
/*																		*/
/************************************************************************/

char *GLOObjName(unsigned int n)
{ return _OInfo[n].Name; }


void GLOGetInfo(unsigned int n,unsigned int *pDamage,unsigned int *pCost,char *pKey)
{
	if (pDamage != NULL) *pDamage = _OInfo[n].MaxDamage;
	if (pCost != NULL) 	 *pCost = _OInfo[n].Cost;
	if (pKey != NULL) 	 *pKey = _OInfo[n].Key;
}

/************************************************************************/
/*																		*/
/*						Return name of attribute						*/
/*																		*/
/************************************************************************/

char *GLOAttribName(unsigned int n)
{
return _AName[n];
}

/************************************************************************/
/*																		*/
/*							Return name of class						*/
/*																		*/
/************************************************************************/

char *GLOClassName(char c)
{
	return (c == 'F') ? "Fighter":"Mage";
}

char *GLOMonsterName(unsigned int n)
{
	return _MInfo[n-1].Name;
}

char *GLOMonsterNameAttribute(int n)
{
	return _MInfoAttribute[n-1];
}

unsigned int GLOMonsterLevel(unsigned int n)
{
	return _MInfo[n-1].Level;
}



