//**********************************************************************
//**********************************************************************
//																		
//							Data Structures								
//																		
//**********************************************************************
//**********************************************************************

typedef struct _Coord						// Coordinate structure 
{ unsigned int x,y; } COORD;

//**********************************************************************

typedef struct _Rect						// Rectangle structure 
{
	int left,top,right,bottom;				// Rectangle coords 
} RECT;

//**********************************************************************

typedef struct _WorldMap					// World Map structure 
{
	unsigned int MapSize;							// Size of map 
	unsigned char Map[WORLD_MAP_SIZE]		// Map information 
							[WORLD_MAP_SIZE];
} WORLDMAP;

//**********************************************************************

typedef struct _Monster						// Monster structure 
{
	COORD Loc;								// Position 
	unsigned int	  Type;								// Monster type 
	unsigned int	  Strength;							// Strength 
	int	  Alive;							// Alive flag 
} MONSTER;

//**********************************************************************

typedef struct _DungeonMap					// Dungeon Map Structure 
{
	unsigned int MapSize;							// Size of Map 
	unsigned char Map[DUNGEON_MAP_SIZE]		// Map information 
							[DUNGEON_MAP_SIZE];
	int	MonstCount;							// Number of Monsters 
	MONSTER Monster[MAX_MONSTERS];			// Monster records 
} DUNGEONMAP;

//**********************************************************************

typedef struct _Player						// Player structure 
{
	char  Name[MAX_NAME+1];					// Player Name 
	COORD World;							// World map position 
	COORD Dungeon;							// Dungeon map position 
	COORD DungDir;							// Dungeon direction facing 
	char  Class;							// Player class (F or M) 
	int   HPGain;							// HPs gained in dungeon 
	unsigned int	  Level;							// Dungeon level, 0 = world map 
	int	  Skill;							// Skill level 
	int	  Task;								// Task set (-1 = none) 
	int	  TaskCompleted;					// Task completed 
	unsigned int	  LuckyNumber;						// Value used for seeding 
	unsigned int	  Attributes;						// Number of attributes 
	unsigned int	  Objects;							// Number of objects 
	unsigned long int  Attr[MAX_ATTR];					// Attribute values 
	unsigned long int  Object[MAX_OBJ];					// Object counts 
} PLAYER;
