//**********************************************************************
//**********************************************************************
//
//                              World Map Code
//
//**********************************************************************
//**********************************************************************
#include <vectrex.h>
#include "controller.h"

#include "aklabeth.h"
#include "string.h"//"os.h"
//**********************************************************************
//
//            Create the world map, set player start position
//
//**********************************************************************

void WORLDCreate(PLAYER *p,WORLDMAP *w)
{
	unsigned int c,x,y,Size;
	//    double v;
	//    srand(p->LuckyNumber);                    // Seed the random number
	setRandSeed(p->LuckyNumber);
	Size = (unsigned int) (MAINSuper()?WORLD_MAP_SIZE-1:20);    // Calculate map size
	w->MapSize = Size;                        // Save the map size
	for (x = 0;x <= Size;x++)                // Draw the boundaries
	{
		w->Map[Size][x] = WT_MOUNTAIN;
		w->Map[0][x] = WT_MOUNTAIN;
		w->Map[x][Size] = WT_MOUNTAIN;
		w->Map[x][0] = WT_MOUNTAIN;
	}
	for (x = 1;x < Size;x++)                // Draw the rest of it
	for (y = 1;y < Size;y++)
	{// c must be a number between: 0-4
		// with a heavy emphasis on lower numbers
		//        c = (int)(pow(RND(),5.0)*4.5);    // Calculate what's there
		//                  if (c == WT_TOWN && RND() > .5)    // Remove half the towns
		//        c = WT_SPACE;
		
		//#define    WT_SPACE        (0)                    /* World Tiles */
		//#define WT_MOUNTAIN        (1)
		//#define WT_TREE            (2)
		//#define    WT_TOWN            (3)
		//#define    WT_DUNGEON        (4)
		//#define    WT_BRITISH        (5)
		//#define    WT_PLAYER        (-1)                /* Used for the player graphic */
		
		
		c = Rand();
		if (c<170) c = 0;
		else if (c<220) c = 1;
		else if (c<248) c = 2;
		else if (c<252) c = 4;
		else  c = 3;
		
		w->Map[x][y] = c;                // Save in map
	}
	// only first time
	x =  Rand() % (Size-1)+1;                // Calculate player start
	y =  Rand() % (Size-1)+1;
	w->Map[x][y] = WT_TOWN;                    // Make it a town
	if ((p->World.x == 0) && (p->World.y == 0))
	{
		p->World.x = x;p->World.y = y;            // Save it
	}
	do                                        // Find place for castle
	{
		x = Rand() % Size + 1;
		y = Rand() % Size + 1;
	}
	while (w->Map[x][y] != WT_SPACE);
	w->Map[x][y] = WT_BRITISH;                // Put LBs castle there
}

//**********************************************************************
//
//                            Read world map value
//
//**********************************************************************

unsigned char WORLDRead(WORLDMAP *w, int x, int y)
{
	if (x < 0 || y < 0) return WT_SPACE;// WT_MOUNTAIN;
	if ((unsigned int)x > 20) return WT_SPACE;
	if ((unsigned int)y > 20) return WT_SPACE;
	return w->Map[x][y];
}



// **********************************************************************
//
//                            Draw world map
//
// **********************************************************************
#define GRID 7
#define _W_ ((unsigned int)(255/GRID))
#define _H_ ((unsigned int)(255/GRID))

#define BLOW_UP 12
const signed char PlayerList[]=
{    (signed char) 0x00, -0x01*BLOW_UP, +0x00*BLOW_UP,  // pattern, y, x
	(signed char) 0xFF, +0x02*BLOW_UP, +0x00*BLOW_UP,  // pattern, y, x
	(signed char) 0x00, -0x01*BLOW_UP, +0x01*BLOW_UP,  // pattern, y, x
	(signed char) 0xFF, +0x00*BLOW_UP, -0x02*BLOW_UP,  // pattern, y, x
	(signed char) 0x01 // endmarker (high bit in pattern not set)
};

void WORLDDrawOnce(PLAYER *p,WORLDMAP *m,int ShowAsMap)
{
	int x1; 
	int y1;
	int x=-128,y;
	unsigned char *toDraw_p;
	
	x1 = (int)p->World.x-(GRID/2);    // Which cell ?
	y1 = (int)p->World.y+(GRID/2);
	
	while (x1<0)
	{
		x1++;
		x+=_W_;
	}
    
	toDraw_p = (unsigned char *)( &m->Map[x1][y1]);
	
	
	for (;x < GRID*_W_-128;x+=_W_)            // For all grid cells
	{
		if (x1>20) break;
		for (y=-128;y < GRID*_H_-128;y+=_H_)
		{
			if ((y1<0) || (y1>20)) {y1--;toDraw_p--; continue;}
                if (*toDraw_p != WT_SPACE)
                {
                    dp_VIA_t1_cnt_lo = 0x4d; // scale
                    				
                    // Moveto_d(y,x);
                    dp_VIA_port_a = y;            // y pos to dac
                    dp_VIA_cntl = (unsigned int)0xce;    // disable zero, disable all blank
                    dp_VIA_port_b = 0;            // mux enable, dac to -> integrator y (and x)
                    asm(" nop"); // cranky vectrex "wait
                    asm(" nop"); // cranky vectrex "wait
                    dp_VIA_port_b++;            // mux disable, dac only to x
                    dp_VIA_port_a = x;            // dac -> x
                    dp_VIA_t1_cnt_hi=0;        // start timer
                    y1--;
                    DRAWTile(*toDraw_p--);
                    dp_VIA_cntl = (unsigned int)0xcc;            // enable zero, enable all blank
                }
			else
			{
				y1--;
				toDraw_p--;
			}
		}
		y1+=GRID;
		toDraw_p+=21+GRID;
		x1++;
	}
	// playeris always right in the middle!
	
	
	VIA_t1_cnt_lo = 0x4d; // scale
	
	// Moveto_d(y1,x1);
	dp_VIA_port_a = (GRID/2)*_H_-128;            // y pos to dac
	dp_VIA_cntl = (unsigned int)0xce;    // disable zero, disable all blank
	dp_VIA_port_b = 0;            // mux enable, dac to -> integrator y (and x)
	dp_VIA_port_b++;            // mux disable, dac only to x
	dp_VIA_port_a = (GRID/2)*_W_-128;            // dac -> x
	dp_VIA_t1_cnt_hi=0;        // start timer
	
	
//	DRAWTile((unsigned char)WT_PLAYER);
	VIA_t1_cnt_lo = 0x60/4 +3-6; // scale
		while ((dp_VIA_int_flags & 0x40) == 0); // wait till timer finishes
		Draw_VLp((void* const)PlayerList);    
    
    
    
    	
	/*
	CLS;
	ADDLINE;
	printfi("PLAYER_X: %", p->World.x);
	printfi("PLAYER_Y: %", p->World.y);
	ADDLINE;
	printfi("WORLD_X: %",  (int)p->World.x-((int)Grid)/2);
	printfi("WORLD_Y: %", (int)p->World.y+((int)Grid)/2);
	*/
}



void WORLDDraw(PLAYER *p,WORLDMAP *m,int ShowAsMap)
{
	while (1)
	{
		CLS;
		Wait_Recal();
		Do_Sound();
		VIA_t1_cnt_lo = 0x80; // scale
		Intensity_a(0x5f); /* set intensity of vector beam... */
		
		WORLDDrawOnce(p,m,ShowAsMap);
		
		check_buttons();
		if (buttons_pressed())
		{
			break;
		}
		
	}
}
